<?php declare (strict_types = 1);

namespace EuKit\Base\Parts;

use Infomaker\Everyware\Base\Models\Post;
use Infomaker\Everyware\Support\GenericPropertyObject;
use Infomaker\Everyware\NewsML\NewsMLTransformerManager;
use Infomaker\Everyware\Support\Interfaces\PropertyObject;
use Infomaker\Everyware\Base\OpenContent\OpenContentProvider;

class Concept extends GenericPropertyObject
{
    public function __construct(PropertyObject $object)
    {
        $this->fill($object->getProperties());
        $this->parseMetadata();
    }
    public function parseMetadata()
    {
        $transformer = NewsMLTransformerManager::createMetaDataTransformer();

        $newsml = $this->meta_data;

        if (!empty($newsml) && is_string($newsml)) {
            $metaData = $transformer->transform($newsml);
            $dar = !empty($metaData) ? $metaData[0]->getProperties() : [];

            $this->set('meta_data', $dar);
        }
    }
    public static function createFromPost(Post $post, $propertyMap = 'Concept')
    {
        $uuid = $post->getMeta('oc_uuid');

        $provider = OpenContentProvider::setup();
        $provider->setPropertyMap($propertyMap);
        $article = $provider->getObject($uuid);

        return new static($article);
    }
}
